#include <catch2/catch.hpp>

#include <gp-bnb/graph.hpp>
#include <gp-bnb/metis_reader.hpp>
#include <gp-bnb/bnb.hpp>

// Tests for Branch&Bound algorithm

TEST_CASE("BnbTest") {

    //test partitioning of tiny graph
    std::string graph = "../test/inputs/tiny_01.graph";
    auto g = metis_reader().read(graph);

    auto sol = gp_bnb::solver(g);
    sol.solve();
    std::vector<partition::subgraph> f= sol.best_solution();

    REQUIRE(f[0] == -1);
    REQUIRE(f[1] == -1);
    REQUIRE(f[2] == -1);
    REQUIRE(f[3] == 1);
    REQUIRE(f[4] == -1);
    REQUIRE(f[5] == 1);
    REQUIRE(f[6] == 1);   


}